#include <stdio.h>
unsigned char han24[1],han48[1],han16[1];
#include "jfc.c"
#define n 9000
#define n1 4096
#define n2 4032
#define r0  2.0              // 2.0*0.454 =0.9"
char head[72][80],f1[30],b[30],c[80],d[150];
FILE   *fp,*fp1,*fp2;
float  see,gain,x1,x2,ava,sig;
float  z1,z2;
int    i0,i1,ic;
double a8[8],b8[8],xx[n],yy[n],x,y,x3,x4,r,cx,cy,pi;
float  sl[n],ber[n];
char   mark[n],c0=34,cc;
int    ccd,m,pg=0;
int    idate;
float  sky,skyrms,see,extin,xmass,expt;
char c1[14],c2[14];
char dir[50],tdir[80],color;
float xlim,w1,w2;
float xl[2],yl[2],u,v,rr[n],r45;
int type;
main(int ac,char **av)
{
  int i,j,k;
  if(ac<2){ printf("\n\t****** use DR10_psf ugriz to calibrating ********* \n");
            printf("\n\tUsage:  c40 e5534g0045_?.fit [!]");
            printf("\n\t        c40 e5534g0045*.fit [!]\n");
            printf("\n\t  out: e5534g0045*.c40\n");     
            printf("\n\t  adjust   /vega2/rhbin/c40.par\n");
            printf("\n\tbefore do:  getcoord d5534g0045.fits");
            printf("\n\tnext maydo: look4 e5534g0045");
            printf("\n\tnext maydo: lookall\n\n");
            exit(0);
          }
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  checkenv("VEGA2");
  strcpy(dir,getenv("VEGA2"));
  sprintf(tdir,"cp %s/rhbin/uefault.param default.param",dir); system(tdir);
  sprintf(tdir,"cp %s/rhbin/uefault.conv default.conv",dir);   system(tdir);
  sprintf(tdir,"cp %s/rhbin/uefault.nnw default.nnw",dir);     system(tdir);
  cc=av[ac-1][0]; if(cc=='!'){ ac--; pg=1; }
  for(i=1;i<ac;i++){ type=0;
    strcpy(f1,av[i]);
    sscanf(&f1[1],"%d",&k);
    idate=0; if(k>5700)idate=1;
    printf("%3d: %s ******\n",i,f1);
//    if(f1[0]!='e'){ printf("not a e*_? file\n"); continue; }
    for(j=0;j<strlen(f1);j++)if(f1[j]=='.')break; f1[j]=0;
    strcat(f1,".fit");
    fp=fopen(f1,"rb+");
    if(fp==0){ printf("%s not found!\n",f1);  continue; }
    fread(head,72,80,fp);
    k=indexpos(head,"A81     ",72);
    for(j=0;j<8;j++)sscanf(&head[k+j][10],"%lf",&a8[j]);
    xytoad(a8,b8);
    if(b8[4]<0. || b8[4]>n1)type=2;
    if(b8[5]<0. || b8[5]>n2)type=2;
    k=indexpos(head,"CCD_NO: ",72); sscanf(&head[k][15],"%d",&ccd);
    k=indexpos(head,"SEEING  ",72); sscanf(&head[k][15],"%f",&see);
/*
    k=indexpos(head,"GAIN    ",72); 
    sscanf(&head[k][10],"%f %f %lf %lf",&x1,&x2,&x3,&x4); gain=(x1+x2+x3+x4)/4.;
*/  gain=1.5;
    strncpy(b,&head[6][53],25);
    for(j=0;j<9;j++)if(b[j]==32)break;
    if(j!=9){ printf("not coordinated! may: coord8u4 %s %\n",f1); continue; }
    k=indexpos(head,"FILTER  ",72); color=head[k][11]; 
if(head[k][11]=='b'&&head[k][12]=='o'&&head[k][13]=='k')color=head[k][14];
    printf("**** COLOR: %c *****\n",color);
    xlim=23.0;
    if(color=='u')xlim=23.0;
    if(color=='g')xlim=22.0;
    if(color=='r')xlim=22.0;
    if(color=='i')xlim=22.0;
    if(color=='z')xlim=22.0;
    sprintf(c,"dr10psf %s 31 %4.1f %c > c4.sl",b,xlim,color);
    printf("%s\n",c);
    system(c);                           // get c4.sl
    m=0;
    fp1=fopen("c4.sl","r");
l10:
    fgets(d,90,fp1); if(feof(fp1))goto l20;
    if(d[0]=='#')goto l10;
    sscanf(&d[35],"%f",&sl[m]);  mark[m]=0;
    chs(&d[7],&x3);  chs(&d[20],&x4);
    rad_xy(a8[6],a8[7],x3,x4,&x,&y,type,0);  
    if(x<10. || x>n1-10.)goto l10;
    if(y<10. || y>n2-10.)goto l10;
    xx[m]=x; yy[m]=y;
// printf("%f %f %f\n",xx[m],yy[m],sl[m]);
    if(m<n-1)m++;
    goto l10;
l20:
    fclose(fp1); 
    if(m<5){ printf("less standard star in this area\n"); continue; }
  
    sprintf(tdir,"%s/rhbin/uefault.sex",dir);
    fp2=fopen(tdir,"r");
    fp1=fopen("default.sex","w");
l30:
    fgets(c,80,fp2); if(feof(fp2))goto l40;
    if(c[0]=='G'&&c[1]=='A'&&c[2]=='I'){sprintf(&c[6],"%4.1f",gain);c[10]=9;}
    if(c[0]=='S'&&c[1]=='E'&&c[2]=='E'){sprintf(&c[12],"%5.2f",see);c[17]=9;}
    fputs(c,fp1); goto l30;
l40:
    fclose(fp1);
    sprintf(c,"sex %s",f1);
    system(c);                           // get test.cat

    w1=15.; w2=21.0;
    sprintf(tdir,"%s/rhbin/c40.par",dir);
    fp1=fopen(tdir,"r");
    if(fp1){
l45:
      fgets(c,80,fp1); if(feof(fp1))goto l46;
      if(c[0]!=color)goto l45;
      sscanf(&c[2],"%f %f",&w1,&w2);
l46:
      fclose(fp1);
    }

    fp1=fopen("test.cat","r");
l50:
    fgets(d,150,fp1);  if(feof(fp1))goto l60;
    if(d[0]=='#')goto l50;
    sscanf(&d[48],"%f %f %lf %lf",&x1,&x2,&x3,&x4);
    if(x1>25.)goto l50;
    r=r0;                      // err 1 pixel, 0.455"
    for(j=0;j<m;j++){
      x=xx[j]-x3; x*=x; 
      y=yy[j]-x4; y*=y; 
      x=sqrt(x+y);
      if(x<r){r=x; k=j; }
    } 
    if(r!=r0){ ber[k]=sl[k]-x1; mark[k]=2;
               if(sl[k]>w2 || sl[k]<w1 )mark[k]=1;
    }
    goto l50;
l60:
    fclose(fp1);
    printf("sl: %4d    0.9%c_match: ",m,c0);
l70:
    x1=x2=0.;
    for(j=k=0;j<m;j++)if(mark[j]==2){ k++; x1+=ber[j]; }
    printf(" %4d ",k);
    ava=x1/k;  
    for(j=0;j<m;j++)if(mark[j]==2) x2+=(ber[j]-ava)*(ber[j]-ava);
    sig=sqrt(x2/k); 
    printf(" av: %6.3f %6.3f\n",ava,sig);
    sig*=3.;
    for(j=ic=0;j<m;j++)if(mark[j]==2){
      x2=ber[j]-ava; if(x2<0.)x2=-x2;
      rr[j]=x2;
      if(x2>sig){ mark[j]=1; ic++; }
    }
    if(ic){ printf("\t  3_sigma_match: "); goto l70;  }
    if(sig>0.2){ r45=0;
      for(j=0;j<m;j++)if(mark[j]==2){
        if(rr[j]>r45){ ic=j; r45=rr[j]; }
      }
      mark[ic]=1; goto l70;
    }
    sig/=3.;  r=pow(10,(ava-4.)*0.4);
    sprintf(&head[29][0],"CALIBRAT=%21.3f / rms:%5.3f   sl:%4d  matched:%4d  W:%7.4lf",
     ava,sig,m,k,r);    for(j=77;j<80;j++)head[29][j]=32;
    printf("Cali:%7.3lf  Weight:%7.3lf    ",ava,r);
// for skyadu,seeing
    sky=see=0;
    j=indexpos(head,"SKYADU  ",72);
    if(j!=72){ sscanf(&head[j][20],"%f",&sky);
               sscanf(&head[j][44],"%f",&skyrms);  }
    j=indexpos(head,"SEEING  ",72);
    if(j!=72)sscanf(&head[j][20],"%f",&see);
    printf("SkyAdu/pixel:%8.2f  Seeing:%5.2f\n",sky,see);
    j=indexpos(head,"EXTINCT ",72);
    if(j!=72)sscanf(&head[j][20],"%f",&extin);
    j=indexpos(head,"AIRMASS ",72);
    if(j!=72)sscanf(&head[j][20],"%f",&xmass);
    j=indexpos(head,"EXPTIME ",72);
    if(j!=72)sscanf(&head[j][10],"%f",&expt);
    if(k<10){ for(j=0;j<80;j++)head[29][j]=32;
              printf("******* less matched (<10), not write down to file\n"); }
    fseek(fp,0,0); fwrite(head,72,80,fp);
    fclose(fp);
// outfile  e5534g0045_?.c40
/*
    strcpy(b,f1); for(j=0;j<strlen(b);j++)if(b[j]=='.')break;
    b[j]=0; strcat(b,".c40");
    fp=fopen(b,"w");
fprintf(fp,"# filename        Exp airmass CaliB. seeing SKYADU   rms   Extinct\n");
fprintf(fp,"%s%7.1f%6.2f%7.3f%6.2f%9.2f%7.2f%8.3f\n",
           f1,expt,xmass,ava,see,sky,skyrms,extin);
    fclose(fp);
*/
    if(pg){
      jfbgft(235,235,255,  0,0,0);  // define pic's back_ground
      jfbegin("",500,500,50);
      x1=13.; x2=23.; z1=9.; z2=19.;
      jfenv(x1,x2,z1,z2,2);
      jflabel("DR10_psf","BOK_Bertin",f1);
      sprintf(c,"Calibration:%8.3f   rms:%6.3f",ava,sig);
      u=13.5;  v=18.5;          jftext(u,v,c);
      sprintf(c,"Weight(FLUX):%7.3f",r);
               v=18.0;          jftext(u,v,c);    
      sprintf(c,"SkyAdu:%8.2f",sky);
               v=17.6;          jftext(u,v,c);    
      sprintf(c,"Seeing:%6.2f",see);
               v=17.2;          jftext(u,v,c);    
      sprintf(c,"Filter:  %c",color);
               v=16.8;          jftext(u,v,c);    
      if(ava>4.){
        yl[0]=z1; xl[0]=yl[0]+ava;
        xl[1]=x2; yl[1]=xl[1]-ava;
      } else {
        xl[0]=x1; yl[0]=xl[0]-ava;
        yl[1]=z2; xl[1]=yl[0]+ava;
      } jfsci(3);
      jfline(2,xl,yl);
      jflp(2);                         // point type
      for(j=0;j<m;j++)if(mark[j]){
        if(mark[j]==1)jfsci(2);
        if(mark[j]==2)jfsci(1);
        x1=sl[j]; x2=sl[j]-ber[j];
        jfpoint(x1,x2);
      }
      jflush();
      getchar();
      jfend(1);
    }    
   
//    outcat();
  }
}

checkenv(char *env)
{
  if(!getenv(env)){printf("in your shell, %s not defined !\n",env); exit(0); }
}

outcat()
{
  int i,j,k;
  k=strlen(f1); f1[k-3]='c'; f1[k-2]='a'; f1[k-1]='t';
  fp=fopen(f1,"w");
  fp1=fopen("test.cat","r");
l10:
  fgets(d,150,fp1);  if(feof(fp1))goto l20;
  if(d[0]!='#'){
    sscanf(&d[48],"%f %f %lf %lf",&x1,&x2,&x3,&x4);
    xy_rad(a8[6],a8[7],x3,x4,&x,&y,type,0);
    toms2(x,c1,1); toms2(y,c2,0);
    sprintf(&d[20],"%s %s",c1,c2); d[46]=32;
  }
  fprintf(fp,"%s",d);
  goto l10;
l20:
  fclose(fp); fclose(fp1);
  k=strlen(f1); f1[k-3]='u'; f1[k-2]='s'; f1[k-1]='l';
  fp=fopen(f1,"w");
  fp1=fopen("c4.sl","r");
l30:
  fgets(d,90,fp1); if(feof(fp1))goto l40;
  if(d[0]!='#'){
    chs(&d[6],&x3);  chs(&d[19],&x4);
    rad_xy(a8[6],a8[7],x3,x4,&x,&y,type,0);  // here: 1 better than 2, 1/4 field
    sprintf(&d[79],"%10.3lf %9.3lf\n",x,y);
  }
  fprintf(fp,"%s",d);
  goto l30;
l40:
  fclose(fp); fclose(fp1);
}

chs(a,y)
char *a; double *y;
{
  double x;
  char b[128];
  int i,j,k;
  strcpy(b,a); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

#define bok  48.
rad_xy(ac,dc,ra,de,x,y,type,k)
double ac,dc,ra,de,*x,*y;  int type,k;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
/*                         // same discribe formula as following 3 lines
  double sd,cd,td,co;      // china bai_ke_quan_shu (astronmy) p.552
  sd=sin(dc);  cd=cos(dc);  td=tan(der);
  co=cos(rar-ac);  tmp=sd*td+cd*co;
  xi=sin(rar-ac)/tmp;
  xn=(cd*td-sd*co)/tmp;
*/
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  if(type==1){     // schmidt TELESCOPE
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=atan(tmp)/tmp;
      xi*=tmp; xn*=tmp;
    }
  }
  if(type==2){    //  BOK telescope
    tmp=1.+bok*(xi*xi+xn*xn);
    xi*=tmp; xn*=tmp;
  }
  if(k==0){
    *x=b8[0]*xi+b8[2]*xn+b8[4];
    *y=b8[1]*xi+b8[3]*xn+b8[5];
  }
  if(k==1){ *x=xi; *y=xn;}
}

xy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);
    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
//                                 printf("%lf\n",tmp);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}

